Package javassist.bytecode

# Class EnclosingMethodAttribute

java.lang.Object
javassist.bytecode.AttributeInfo
javassist.bytecode.EnclosingMethodAttribute

public class EnclosingMethodAttribute extends AttributeInfo
`EnclosingMethod_attribute`.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`tag`
The name of this attribute `"EnclosingMethod"`.

## Constructor Summary

Constructors
Constructor
Description
`EnclosingMethodAttribute(ConstPool cp, String className)`
Constructs an EnclosingMethod attribute.
`EnclosingMethodAttribute(ConstPool cp, String className, String methodName, String methodDesc)`
Constructs an EnclosingMethod attribute.

## Method Summary

Modifier and Type
Method
Description
`int`
`classIndex()`
Returns the value of `class_index`.
`String`
`className()`
Returns the name of the class specified by `class_index`.
`AttributeInfo`
`copy(ConstPool newCp, Map<String,String> classnames)`
Makes a copy.
`String`
`methodDescriptor()`
Returns the method descriptor specified by `method_index`.
`int`
`methodIndex()`
Returns the value of `method_index`.
`String`
`methodName()`
Returns the method name specified by `method_index`.

### Methods inherited from class javassist.bytecode.AttributeInfo

`get, getConstPool, getName, length, set`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### tag

public static final String tag
The name of this attribute `"EnclosingMethod"`.

See Also:
  - Constant Field Values

## Constructor Details

### EnclosingMethodAttribute

public EnclosingMethodAttribute(ConstPool cp, String className, String methodName, String methodDesc)
Constructs an EnclosingMethod attribute.

Parameters:
  `cp` - a constant pool table.
  `className` - the name of the innermost enclosing class.
  `methodName` - the name of the enclosing method.
  `methodDesc` - the descriptor of the enclosing method.

### EnclosingMethodAttribute

public EnclosingMethodAttribute(ConstPool cp, String className)
Constructs an EnclosingMethod attribute. The value of `method_index` is set to 0.

Parameters:
  `cp` - a constant pool table.
  `className` - the name of the innermost enclosing class.

## Method Details

### classIndex

public int classIndex()
Returns the value of `class_index`.

### methodIndex

public int methodIndex()
Returns the value of `method_index`.

### className

public String className()
Returns the name of the class specified by `class_index`.

### methodName

public String methodName()
Returns the method name specified by `method_index`. If the method is a class initializer (static constructor), `MethodInfo.nameClinit` is returned.

### methodDescriptor

public String methodDescriptor()
Returns the method descriptor specified by `method_index`.

### copy

public AttributeInfo copy(ConstPool newCp, Map<String,String> classnames)
Makes a copy. Class names are replaced according to the given `Map` object.

Overrides:
  `copy` in class `AttributeInfo`
Parameters:
  `newCp` - the constant pool table used by the new copy.
  `classnames` - pairs of replaced and substituted class names.